// Buczko Tamas
// ThreadTest 2006
// Siemens PSE
package test.code;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

public class CodeWorker extends Thread {
    
    private long min; // Kodolas kezdo pozicioja (byte)
    private long max; // Kodolas vege (byte)
    
    public CodeWorker(long from, long to) {
        min = from;
        max =  to;
    }
    
    public void run() {
        try {
            File myFile = new File(CodeFarmer.JOB_DIR, "TID" +
                    Long.toString(Thread.currentThread().getId()) + ".txt");
            FileOutputStream myFileOutputStream = new FileOutputStream(myFile);
            FileInputStream myFileInputStream = new FileInputStream(CodeFarmer.JOB_FILE);
            myFileInputStream.skip(min);
            byte buffer[] = new byte[128];
            int i = 0;
            while(i < (max-min)) {
                int length = myFileInputStream.read(buffer);
                i += length;
                if(length == -1) {
                    break;
                }
                myFileOutputStream.write(getCode(buffer, length));
                myFileOutputStream.flush();
            }
            myFileOutputStream.close();
            myFileInputStream.close();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
    
    // Nem tul ertelmes kodolas, a megelozo paros
    // byte-okat hozzaadja a paratlanokat kivonja
    private byte[] getCode(byte buffer[], int length) {
        byte code[] = new byte[length];
        for(int i = 0; i < length; i++) {
            code[i] = buffer[i];
            for(int j = 0; j < i; j+=2) {
                code[i] += buffer[j];
                code[i] -= buffer[j+1];
            }
        }
        return code;
    }
}
