// Buczko Tamas
// ThreadTest 2006
// Siemens PSE
package test.prime;

public class PrimeWorker extends Thread {
    
    private int min; // Keresesi tartomany eleje
    private int max; // Keresesi tartomany vege
    private long op; // Vegrehajtott muveletek szama
    private PrimeFarmer myFarmer;
    
    public long getOperation(){
        return op;
    }
    
    public PrimeWorker(PrimeFarmer farmer, int from, int to) {
        myFarmer = farmer;
        min = from;
        max =  to;
        op = 0;
    }
    
    public void run() {
        // BruteForce :)
        String primes = "";
        boolean prime = true;
        for(int i = min; i < max; i++) {
            prime = true;
            for(int j = 2; j <= i/2; j++) {
                if(i%j==0) prime = false;
                op++;
            }
            if(prime) primes = primes.concat(Integer.toString(i)).concat(",");
        }
        myFarmer.println(Integer.toString(min) + "-" + Integer.toString(max) + "\t" + primes);
    }
    
}
