// Buczko Tamas
// ThreadTest 2006
// Siemens PSE
package test.multiple;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class MultipleWorker extends Thread {
    
    private int jobCount; // Fajl ismetlese
    
    public MultipleWorker(int jCount) {
        jobCount = jCount;
    }
    
    public void run() {
        String strTID = Long.toString(Thread.currentThread().getId());
        try {
            for(int i = 0; i < jobCount; i++) {
                PrintWriter myPrintWriter = new PrintWriter(new FileWriter(new File(MultipleFarmer.JOB_DIR,
                        strTID.concat("#").concat(Integer.toString(i)).concat("_").concat("output.txt"))));
                
                for(int j = 0; j < MultipleFarmer.LINE_COUNT; j++) {
                    myPrintWriter.println(MultipleFarmer.LINE);
                    myPrintWriter.flush();
                }
                if (myPrintWriter != null) {
                    myPrintWriter.close();
                }
            }
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
}
